jQuery(function ($) {

    var inputString = new Url(Settings.feedUrl).path.split('/')[1];

    if (inputString == '') {
        inputString = 'Appsgeyser';
    }

    var apiKeys = ['688699674607483|uwx7npEtFZaRmkQU_RLuPLXKWKQ', '688699561274161|fzc6e_GW7jk6tnLN1RdrwhsWPBY', '688735067937277|fvDCB4k1QWvTvlhwmxRa8nr_yA0', '688735291270588|iCram5V-qwwDqWQG4JqxwxHCLdQ'],

        apiKey = apiKeys[Math.floor(Math.random() * apiKeys.length)],

        $container = $('#posts'),

        $containerFoto = $('#photo'),

        $background = $('#backgrounds'),

        $backgroundImages = $('#backgrounds-images'),

        standardUrlPost = 'https://graph.facebook.com/' + inputString + '/posts/?access_token=' + apiKey + '',

        standardUrlPhoto = 'https://graph.facebook.com/' + inputString + '/photos/?type=uploaded&access_token=' + apiKey + '';

    $('body').css({backgroundColor: '#' + Settings.bgColor});

    $('.collection').css({backgroundColor: '#' + Settings.bgColor});

    $('#fixed').css({backgroundColor: '' + Settings.themeColors.colorPrimaryDark});
	
    // Получаем имя запр-ой страницы
    function getNamePage(div) {
        $.getJSON('https://graph.facebook.com/Appsgeyser/?&access_token=' + apiKey + '', function (data) {
            $(div).append('<span class="truncate">' + data.name + '</span>');
            $('#name').append(data.name);
        }).error(function(msg) {
            var txt = msg.responseJSON.error.message;
            if(txt == '(#4) Application request limit reached'){
                txt += '\n Please refresh application';
            }
            $('.start_preloaded').hide();
            $('.loader').hide();
            $('.container').html('<h4 class="center" style="margin-top: 180px;">'+txt+'</h4>').show();
        });
    }

    // Получаем logo запр-ой страницы
    function getLogoPage() {
        $('#logo').append('<div class="img" style="background-image: url(https://graph.facebook.com/' + inputString + '/picture?&access_token=' + apiKey + ')"></div>');
    }

    // Получаем изображение поста
    function getImagePost(id) {
        $.getJSON('https://graph.facebook.com/' + id + '?fields=full_picture,picture&access_token=' + apiKey + '',
            function (img) {
                if (img.full_picture !== undefined) {
                    $('[data-id = fbPost-' + id + '] img').attr('src', img.full_picture);
                } else {
                    $('[data-id = fbPost-' + id + '] img').detach();
                }
            }
        )
    }

    // Получаем суммарное количество лайков и комментов
    function getLikeAndGetCommentsPage(id) {
        $.getJSON('https://graph.facebook.com/' + id + '/likes?summary=true&access_token=' + apiKey + '', function (like) {
            var $like = $('#like_' + id);
            if ($like.text() == '') {
                $like.append('<span>' + numeral(like.summary.total_count).format('0a') + '</span>');
            } else {
                $like.detach();
                $like.append('<span>' + numeral(like.summary.total_count).format('0a') + '</span>');
            }
        })
        $.getJSON('https://graph.facebook.com/' + id + '/comments?summary=true&access_token=' + apiKey + '', function (comment) {
            var $comment = $('#comment_' + id);
            if ($comment.text() == '') {
                $comment.append('<span>' + numeral(comment.summary.total_count).format('0a') + '</span>');
            } else {
                $comment.detach();
                $comment.append('<span>' + numeral(comment.summary.total_count).format('0a') + '</span>');
            }
        })
    }

    function getCoverPage() {
        $.getJSON('https://graph.facebook.com/' + inputString + '?fields=cover&access_token=' + apiKey + '', function (data) {
            if (data.cover !== undefined) {
                $background.attr("src", "" + data.cover.source + "");
            } else {
                $backgroundImages.append('<div class="img" style="background-image: url(https://graph.facebook.com/' + inputString + '/picture?&access_token=' + apiKey + ')"></div>');
                $('head').append('<link href="css/no-cover.css" type="text/css" rel="stylesheet" media="screen,projection"/>')
            }
        }).error(function(msg) {
            var txt = msg.responseJSON.error.message;
            if(txt == '(#4) Application request limit reached'){
                txt += '\n Please refresh application';
            }
            $('.start_preloaded').hide();
            $('.loader').hide();
            $('.container').html('<h4 class="center" style="margin-top: 180px;">'+txt+'</h4>').show();
        });
        getPostPage();
    }

    function getPostPage() {
        $.getJSON(standardUrlPost, function (data) {
            getNewPostPage(data.paging.next);
            if ('AppsgeyserJSInterface' in window) {
                AppsgeyserJSInterface.setItem('lastPostTime', data.data[0].created_time);
            }
            $.each(data.data, function (key, value) {
                // Проверка на существование сообщения, если нету, то ебнем че-нить другое
                if (value.message !== undefined) {
                    message = value.message;
                } else {
                    message = value.story;
                }
                getLikeAndGetCommentsPage(value.id);

                $container.append(
                    '<div class="col s12 m6 l6"><div class="card" data-id="fbPost-' + value.id + '">' +
                    '<div class="card-image waves-effect waves-block waves-light">' +
                    '<img class="activator" src="' + getImagePost(value.id) + '">' +
                    '</div>' +
                    '<div class="card-content"><p>' + linkify(message) + '</p></div>' +
                    '</div></div>'
                );
            });
            $('.start_preloaded').hide();
            $('.container').show();
            $('.loader').hide();
        }).error(function(msg) {
            var txt = msg.responseJSON.error.message;
            if(txt == '(#4) Application request limit reached'){
                txt += '\n Please refresh application';
            }
            $('.start_preloaded').hide();
            $('.loader').hide();
            $('.container').html('<h4 class="center" style="margin-top: 180px;">'+txt+'</h4>').show();
        });
    }

    function getNewPostPage(next) {
        var inProgress = false;
        var url = next;
        $(window).scroll(function () {
            if ($(window).scrollTop() + $(window).height() >= $(document).height() - 200 && !inProgress) {
                $.ajax({
                    url: url, method: 'GET', beforeSend: function () {
                        inProgress = true;
                    }
                }).done(function (data) {
                    if (data.data == undefined) {
                        $('.progress').fadeOut();
                    } else if (data.data == '') {
                        $('.progress').fadeOut();
                    } else {
                        $('.progress').fadeIn();
                    }
                    if (data.data.length > 0) {
                        url = data.paging.next;
                        $.each(data.data, function (key, value) {

                            // Проверка на существование сообщения, если нету, то ебнем че-нить другое
                            if (value.message !== undefined) {
                                message = value.message;
                            } else {
                                message = value.story;
                            }

                            getLikeAndGetCommentsPage(value.id);
                            $container.append(
                                '<div class="card" data-id="fbPost-' + value.id + '">' +
                                '<div class="card-image waves-effect waves-block waves-light">' +
                                '<img class="activator" src="' + getImagePost(value.id) + '">' +
                                '</div>' +
                                '<div class="card-content"><p>' + linkify(message) + '</p></div>' +
                                '</div>'
                            );
                        });
                        inProgress = false;
                    }
                });
            }
        });
    }

    function getPhotoPage() {
        $.getJSON(standardUrlPhoto, function (data) {
            getNewAlbumsPage(data.paging.next);
            $.each(data.data, function (key, value) {
                $containerFoto.append(
                    '<div class="imag-photo" id="' + value.id + '" data-src="https://graph.facebook.com/' + value.id + '/picture?type=normal&access_token=' + apiKey + '" >' +
                    '<div style="background-image: url(https://graph.facebook.com/' + value.id + '/picture?type=normal&access_token=' + apiKey + ');  width: 100%;height: 80px;background-size: cover;" id="' + value.id + '" ' +
                    'class="zoom-images" >' +
                    '</div>'
                );
            });
        }).error(function(msg) {
            var txt = msg.responseJSON.error.message;
            if(txt == '(#4) Application request limit reached'){
                txt += '\n Please refresh application';
            }
            $('.start_preloaded').hide();
            $('.loader').hide();
            $('.container').html('<h4 class="center" style="margin-top: 180px;">'+txt+'</h4>').show();
        })
    }

    function getNewAlbumsPage(next) {
        var inProgress = false;
        var url = next;
        $(window).scroll(function () {
            if ($(window).scrollTop() + $(window).height() >= $(document).height() - 200 && !inProgress) {
                $.ajax({
                    url: url, method: 'GET', beforeSend: function () {
                        inProgress = true;
                    }
                }).done(function (data) {
                    if (data.data == undefined) {
                        $('.progress').fadeOut();
                    } else if (data.data == '') {
                        $('.progress').fadeOut();
                    } else {
                        $('.progress').fadeIn();
                    }
                    if (data.data.length > 0) {
                        url = data.paging.next;
                        $.each(data.data, function (key, value) {
                            $containerFoto.append(
                                '<div class="imag-photo" id="' + value.id + '" data-src="https://graph.facebook.com/' + value.id + '/picture?type=normal&access_token=' + apiKey + '" >' +
                                '<div style="background-image: url(https://graph.facebook.com/' + value.id + '/picture?type=normal&access_token=' + apiKey + ');  width: 100%;height: 80px;background-size: cover;" id="' + value.id + '" ' +
                                'class="zoom-images" >' +
                                '</div>'
                            );
                        });
                        inProgress = false;
                    }
                });
            }
        });
    }

    $(document).on('click', '.imag-photo', function () {
        $('body').prepend('<div id="photos" class="valign-wrapper">' +
            '<img src="https://graph.facebook.com/' + this.id + '/picture?type=normal&access_token=' + apiKey + '" id="images-photo" />' +
            '</div>')
    });
    $(document).on('click', '#photos', function () {
        $('#photos').detach();
    });
    window.onscroll = function () {
        var scrolled = window.pageYOffset || document.documentElement.scrollTop;
        if (scrolled >= 0) {
            $('#photos').detach();
        }
    }
	
	$(document).on('click', '.activator', function () {
        var id = $(this).parent().parent().data('id').split('_');
        location.href = 'https://www.facebook.com/' + inputString + '/posts/' + id[1] + '';
    });
	
	$(document).on('click', '.card-content', function () {
		var id = $(this).parent().data('id').split('_');
		location.href = 'https://www.facebook.com/' + inputString + '/posts/' + id[1] + '';
	});

    getNamePage('#fixed');
    getLogoPage();
    getPhotoPage();

    
    // ссылки в тексте активными*
    function linkify(inputText) {
        var replacedText, replacePattern1, replacePattern2, replacePattern3;

        //URLs starting with http://, https://, or ftp://
        replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
        replacedText = inputText.replace(replacePattern1, '<a href="$1" target="_blank">$1</a>');

        //URLs starting with "www." (without // before it, or it'd re-link the ones done above).
        replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
        replacedText = replacedText.replace(replacePattern2, '$1<a href="http://$2" target="_blank">$2</a>');

        //Change email addresses to mailto:: links.
        replacePattern3 = /(\s(g\.co)\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
        replacedText = replacedText.replace(replacePattern3, '<a href="$1">$1</a>');

        return replacedText;
    }

    // enb\dis notifications
    $(document).on('click', '#notifications', function () {
        var value = $(this).prop("checked");
        if ('AppsgeyserJSInterface' in window) {
            AppsgeyserJSInterface.setItem('notifications', value);
        }
    });

    if ('AppsgeyserJSInterface' in window) {
        AppsgeyserJSInterface.setItem('inputString', inputString);
        var ONE_HOUR = 1000 * 60 * 60;

        var notifications = AppsgeyserJSInterface.getItem('notifications');
        if (notifications !== 'false') {
            AppsgeyserJSInterface.setItem('notifications', true);
            AppsgeyserJSInterface.registerUpdateChecker('checker.html', ONE_HOUR);
            $('#notifications').prop('checked', true);
        } else {
            AppsgeyserJSInterface.setItem('notifications', false);
            AppsgeyserJSInterface.removeUpdateChecker('checker.html');
            $('#notifications').prop('checked', false);
        }
    }
    getCoverPage();
    $('ul.tabs').tabs();
    $('head').append('' +
        '<style>' +
        '.start_preloaded{background-color: '+Settings.themeColors.colorPrimary+'}' +
        '.tabs .indicator{background-color: '+Settings.themeColors.colorPrimary+'}' +
        '.tabs .tab a{color: '+Settings.themeColors.colorPrimaryDark+'}' +
        '.tabs .tab a:hover{opacity:0.7;color: '+Settings.themeColors.colorPrimaryDark+'}' +
        '.waves-effect.waves-light .waves-ripple{background-color: '+hexToRgb(Settings.themeColors.colorPrimaryDark)+'}' +
        '</style>' +
        '');
	console.log("%cStop!", "color: red; font-family: sans-serif; font-size: 4.5em;text-transform:; font-weight: bolder; text-shadow: #000 1px 1px;");
    console.image("http://i.imgur.com/oGiMR.gif");
});
function hexToRgb(hex) {
    var bigint = parseInt(hex.replace(/#/,''), 16);
    var r = (bigint >> 16) & 255;
    var g = (bigint >> 8) & 255;
    var b = bigint & 255;

    return 'rgba('+r+', '+g+', '+b+', 0.41)';
}
/**
 * Dubiously created by Adrian Cooney
 * http://adriancooney.github.io
 */
(function(console) {
    "use strict";

    //Bootlegged of imgur.com/memegen
    var memes = {"10 Guy":"//i.imgur.com/LaENqOV.jpg","3rd World Success Kid":"//i.imgur.com/WA5duA1.jpg","90's Problems":"//i.imgur.com/tL47qtp.jpg","Aaand It's Gone":"//i.imgur.com/yf12saq.jpg","Actual Advice Mallard":"//i.imgur.com/WymFmVy.jpg","Advice Dog":"//i.imgur.com/Qk0VO6D.jpg","Advice God":"//i.imgur.com/xH2fSFg.jpg","Almost Politically Correct Redneck":"//i.imgur.com/YqLgINf.jpg","Am I The Only One":"//i.imgur.com/gS9YL5U.jpg","Ancient Aliens":"//i.imgur.com/NfCknz0.jpg","Annoyed Picard":"//i.imgur.com/s9GmfSS.jpg","Annoying Childhood Friend":"//i.imgur.com/27VCyQw.jpg","Annoying Facebook Girl":"//i.imgur.com/ccczyGt.jpg","Anti-Joke Chicken (Rooster)":"//i.imgur.com/KOsW0jh.jpg","Awkward Penguin":"//i.imgur.com/ez1tQrq.jpg","Back In My Day Grandpa":"//i.imgur.com/zuJSZp8.jpg","Bad Advice Mallard":"//i.imgur.com/QEPvL2B.jpg","Bad Luck Brian":"//i.imgur.com/sRW8BiO.jpg","Bear Grylls":"//i.imgur.com/6Spqy1D.jpg","Brace Yourself":"//i.imgur.com/NhIq0LY.jpg","Captain Obvious":"//i.imgur.com/DmUcxBu.jpg","Chemistry Cat":"//i.imgur.com/8agP4Xe.jpg","College Freshman":"//i.imgur.com/2Ynyv9t.jpg","College Liberal":"//i.imgur.com/OWfvSFE.jpg","Condescending Wonka":"//i.imgur.com/D0e5fgL.jpg","Confession Bear":"//i.imgur.com/kH1SKhp.jpg","Confession Kid":"//i.imgur.com/jhOxR12.jpg","Confused Gandalf":"//i.imgur.com/iIb5SEo.jpg","Conspiracy Keanu":"//i.imgur.com/pFyk3J7.jpg","Courage Wolf":"//i.imgur.com/H5qoXFb.jpg","Dating Site Murderer":"//i.imgur.com/jffNNql.jpg","Depression Dog":"//i.imgur.com/wgad6P8.jpg","Drunk Baby":"//i.imgur.com/QvZdbRE.jpg","English Motherfucker":"//i.imgur.com/sJThEC0.jpg","Evil Plotting Raccoon":"//i.imgur.com/xMslWFf.jpg","First Day On The Internet Kid":"//i.imgur.com/TWfdmVu.jpg","First World Cat Problems":"//i.imgur.com/0vR5Slq.jpg","First World Problem":"//i.imgur.com/ATcIl08.jpg","Forever Alone":"//i.imgur.com/pcfXSUU.jpg","Forever Resentful Mother":"//i.imgur.com/pIrdwo2.jpg","Foul Bachelor Frog":"//i.imgur.com/JUFmusm.jpg","Foul Bachelorette Frog":"//i.imgur.com/dYf971U.jpg","Friendzone Fiona":"//i.imgur.com/Qu1eedL.jpg","Frustrated Farnsworth":"//i.imgur.com/U3SElKP.jpg","Fuck Me, Right?":"//i.imgur.com/J9gfxsx.jpg","Gangster Baby":"//i.imgur.com/C3XhI56.jpg","Good Girl Gina":"//i.imgur.com/qK6lYr2.jpg","Good Guy Greg":"//i.imgur.com/UXMPoKN.jpg","Grandma Finds The Internet":"//i.imgur.com/xPfGYqu.jpg","Grinds My Gears":"//i.imgur.com/t4JqU1j.jpg","Grumpy Cat (Tard)":"//i.imgur.com/dU5CDxN.jpg","High Expectations Asian Father":"//i.imgur.com/7QeB9LI.jpg","Hipster Barista":"//i.imgur.com/AbWxdy2.jpg","Horrifying House Guest":"//i.imgur.com/DxmoFp1.jpg","I Dare You Samuel Jackson":"//i.imgur.com/UQtpdqj.jpg","I Should Buy A Boat":"//i.imgur.com/XqlqPxn.jpg","I Too Like To Live Dangerously":"//i.imgur.com/qF70EL9.jpg","Idiot Nerd Girl":"//i.imgur.com/8hYPYwd.jpg","Insanity Wolf":"//i.imgur.com/GOOdg3k.jpg","Joker Mind Loss":"//i.imgur.com/qQIRaOD.jpg","Joseph Ducreux":"//i.imgur.com/QL7TyR9.jpg","Lame Joke Eel":"//i.imgur.com/oQXw3jF.jpg","Lame Pun Raccoon":"//i.imgur.com/nvALRK3.jpg","Lazy College Senior":"//i.imgur.com/PpkVfzz.jpg","Mad Karma":"//i.imgur.com/G0QMPum.jpg","Masturbating Spidey":"//i.imgur.com/dZ7AB4c.jpg","Matrix Morpheus":"//i.imgur.com/8Yrw6cZ.jpg","Mayonnaise Patrick":"//i.imgur.com/5jE0Y7f.jpg","Musically Oblivious 8th Grader":"//i.imgur.com/l5YHN5D.jpg","Not Sure Fry":"//i.imgur.com/7rFgBB1.jpg","Oblivious Suburban Mom":"//i.imgur.com/Y7o7UJs.jpg","One Does Not Simply":"//i.imgur.com/7LrwR1Y.jpg","Overly Attached Girlfriend":"//i.imgur.com/5blLJLR.jpg","Overly Manly Man":"//i.imgur.com/dOSn9Na.jpg","Paranoid Parrot":"//i.imgur.com/KooYHdg.jpg","Pedobear":"//i.imgur.com/c6JZKRW.jpg","Pepperidge Farm Remembers":"//i.imgur.com/uFde4v5.jpg","Philosoraptor":"//i.imgur.com/eERhI5h.jpg","Priority Peter":"//i.imgur.com/BBEFk0e.jpg","Rasta Science Teacher":"//i.imgur.com/Js6Ai5T.jpg","Redditor's Wife":"//i.imgur.com/d1XfJeD.jpg","Revenge Band Kid":"//i.imgur.com/dlvmaRI.jpg","Schrute Facts":"//i.imgur.com/UxcvPwT.jpg","Scumbag Brain":"//i.imgur.com/OZhhZdS.jpg","Scumbag Stacy":"//i.imgur.com/Qqz1axp.jpg","Scumbag Steve":"//i.imgur.com/Rfvoc0Y.jpg","Sexually Oblivious Rhino":"//i.imgur.com/RoaNuEC.jpg","Sheltering Suburban Mom":"//i.imgur.com/vMkSofv.jpg","Shut Up And Take My Money":"//i.imgur.com/uWe0rtQ.jpg","Skeptical Third World Kid":"//i.imgur.com/uwAusxV.jpg","Smug Spongebob":"//i.imgur.com/OTTRjrv.jpg","Socially Awesome Penguin":"//i.imgur.com/S6WgQW7.jpg","Success Kid":"//i.imgur.com/ZibijBz.jpg","Successful Black Man":"//i.imgur.com/ogIm0cy.jpg","Sudden Clarity Clarence":"//i.imgur.com/N3Xmfbe.jpg","Tech Impaired Duck":"//i.imgur.com/riz28ci.jpg","The Most Interesting Man In The World":"//i.imgur.com/MGv15MH.jpg","The Rent Is Too High":"//i.imgur.com/r5WLktQ.jpg","Tough Spongebob":"//i.imgur.com/2w0F1HX.jpg","Unhelpful Highschool Teacher":"//i.imgur.com/ohbGhuD.jpg","Vengeance Dad":"//i.imgur.com/0nUStsa.jpg","What Year Is It?":"//i.imgur.com/fj79hQS.jpg","X, X Everywhere":"//i.imgur.com/GGy94Gt.jpg","Yeah That'd Be Great":"//i.imgur.com/nz9M2pl.jpg","Yo Dawg Xzibit":"//i.imgur.com/XOyGqF2.jpg","You're Bad And You Should Feel Bad":"//i.imgur.com/YsabGnQ.jpg","You're Gonna Have A Bad Time":"//i.imgur.com/2tNR7P7.jpg"};

    /**
     * Since the console.log doesn't respond to the `display` style,
     * setting a width and height has no effect. In fact, the only styles
     * I've found it responds to is font-size, background-image and color.
     * To combat the image repeating, we have to get a create a font bounding
     * box so to speak with the unicode box characters. EDIT: See Readme.md
     *
     * @param  {int} width  The height of the box
     * @param  {int} height The width of the box
     * @return {object}     {string, css}
     */
    function getBox(width, height) {
        return {
            string: "+",
            style: "font-size: 1px; padding: " + Math.floor(height/2) + "px " + Math.floor(width/2) + "px; line-height: " + height + "px;"
        }
    }

    /**
     * Draw's meme text on a context.
     *
     * @param  {CanvasRenderingContext2D} ctx   The canvas context
     * @param  {string} type  "upper"|"lower"
     * @param  {string} text  The text to draw
     * @param  {int} width The width of the image
     * @param  {int} y     The y value to draw at
     * @return {null}
     */
    function drawMemeText(ctx, type, text, width, y) {
        text = text.toUpperCase();
        //Determine the font size
        if(text.length < 24) {
            var val = Math.max(0, text.length - 12),
                size = 70 + (val * - 3);

            drawText(ctx, size, text, width/2, y);
        } else if(text.length < 29) {
            drawText(ctx, 40, text, width/2, y);
        } else {
            var strs = wrap(text, 27);
            strs.forEach(function(str, i) {
                drawText(ctx, 40, str, width/2, (type == "lower") ? (y - ((strs.length - 1) * 40)) + (i * 40) : y + (i * 40));
            });
        }
    }

    /**
     * Draws text in impact font with stroke on context
     *
     * @param  {CanvasRenderingContext2D} ctx  The canvas context
     * @param  {int} size Font size
     * @param  {string} text The string to write
     * @param  {int} x    X Position
     * @param  {int} y    Y position
     * @return {null}
     */
    function drawText(ctx, size, text, x, y) {
        //Set the text styles
        ctx.font = "bold " + size + "px Impact";
        ctx.fillStyle = "#fff";
        ctx.textAlign = "center";
        ctx.textBaseline = "middle";
        ctx.lineWidth = 7;
        ctx.strokeStyle = "#000";
        ctx.strokeText(text, x, y);
        ctx.fillText(text, x, y);
    }

    /**
     * Wrap a line of text at an index
     *
     * @param  {string} text The text
     * @param  {int} num  The index to wrap at
     * @return {array}      Array of text
     */
    function wrap(text, num) {
        var output = [],
            split = text.split(" ");

        var str = [];
        for(var i = 0, cache = split.length; i < cache; i++) {
            if((str + split[i]).length < num) str.push(split[i])
            else {
                output.push(str.join(" "));
                str.length = 0;
                str.push(split[i]);
            }
        }

        //Push the final line
        output.push(str.join(" "));

        return output;
    }

    /**
     * Add a meme to the console!
     *
     * @param  {string} upper  The upper text
     * @param  {string} lower  The lower text
     * @param  {string} image  The meme type (see `console.meme` for all supported) or image url (Make sure it's CORS enabled)
     * @param  {int} width  The width of the meme
     * @param  {int} height The height of the meme
     * @return {null}
     */
    console.meme = function(upper, lower, image, width, height) {
        if(!upper) console.error("Yo, you forgot the text for the upper part of the meme. The bit at the top. Yeah, that bit.");
        if(!lower) console.error("You forgot the text for the bottom of the meme, stupid.");
        if(!image) console.error("Dude, you forgot the meme type or url for the background image (CORS enabled, *hint* imgur *hint*). To see a list of supported memes, hit `console.meme()`");
        if(!upper && !lower && !image) return console.log("> " + Object.keys(memes).join("\n> "));

        var canvas = document.createElement("canvas"),
            ctx = canvas.getContext("2d"),
            width = width || 500,
            height = width || 500,
        //I tweaked it at these dimensions,
        //So everything scales from here
            _w = 500, _h = 500;

        var img = new Image();
        img.setAttribute('crossOrigin','anonymous');
        img.onload = function() {
            canvas.width = width;
            canvas.height = height;

            var text = upper.toUpperCase();

            ctx.scale(width/500, height/500);

            //Draw the background
            ctx.drawImage(this, 0, 0, _w, _h);

            drawMemeText(ctx, "upper", upper, _w, 50); //upper
            drawMemeText(ctx, "lower", lower, _w, _h - 50); //upper

            console.image(canvas.toDataURL());
        };

        if(memes[image]) var url = memes[image];
        else var url = image;

        img.src = url; //"http://www.corsproxy.com/" + url.replace(/https?:\/\//, "");
    };

    /**
     * Display an image in the console.
     * @param  {string} url The url of the image.
     * @param  {int} scale Scale factor on the image
     * @return {null}
     */
    console.image = function(url, scale) {
        scale = scale || 1;
        var img = new Image();

        img.onload = function() {
            var dim = getBox(this.width * scale, this.height * scale);
            console.log("%c" + dim.string, dim.style + "background: url(" + url + "); background-size: " + (this.width * scale) + "px " + (this.height * scale) + "px; color: transparent;");
        };

        img.src = url;
    };
})(console);